



//run multiple tests

public class shepardCExperiment extends CANTExperiment {
	
  public int numTests = 40;
  
  private int trainTestNet[][];//offset,trainInstances
  private int trainTestInput;
  private int testNet[];
  private int firstTestAnswerCycle=0;

  public shepardCExperiment () {
    //trainingLength = 36000; 
	trainingLength = 24000; 
    inTest = false;
	shepardCNet somNet = (shepardCNet) getNet("SomNet");
    int somNetSize = somNet.getSize();
    trainTestInput = 0;
    testNet = new int[somNetSize];
  }
  
  public boolean experimentDone(int CANTStep) {
	if (CANTStep > trainingLength +  (75 * numTests+1))
		return true;
    return false;  
  }
  
	private void printSynapticStrength() {
		double inputToSom = 0;
		double somToHidden = 0;
		double hiddenToSom = 0;
		double hiddenToOutput = 0;
		double outputToHidden = 0;
		double somToSom = 0;
		double hiddenToHidden = 0;
		double outputToOutput = 0;

		shepardCNet inputNet = (shepardCNet) getNet("BaseNet");
		shepardCNet somNet = (shepardCNet) getNet("SomNet");
		shepardCNet hiddenNet = (shepardCNet) getNet("HiddenNet");
		shepardCNet outputNet = (shepardCNet) getNet("OutputNet");

		for (int neuronNum = 0; neuronNum < 1000; neuronNum++) {
			inputToSom = 0;
			somToHidden = 0;
			hiddenToSom = 0;
			hiddenToOutput = 0;
			outputToHidden = 0;
			somToSom = 0;
			hiddenToHidden = 0;
			outputToOutput = 0;
			
			// input
			int relevantSynapses = 0;
			if (neuronNum < 550) {
						for (int synapse = 0; synapse < inputNet.neurons[neuronNum]
						.getCurrentSynapses(); synapse++) {
					CANTNeuron toNeuron = inputNet.neurons[neuronNum].synapses[synapse].toNeuron;
					if (toNeuron.parentNet.getName().compareTo("SomNet") == 0) {
						inputToSom += inputNet.neurons[neuronNum].synapses[synapse]
								.getWeight();
						relevantSynapses++;
					}
				}
				inputToSom /= relevantSynapses;
			}

			// som
			relevantSynapses = 0;
			int forwardSynapses = 0;
			for (int synapse = 0; synapse < somNet.neurons[neuronNum]
					.getCurrentSynapses(); synapse++) {
				CANTNeuron toNeuron = somNet.neurons[neuronNum].synapses[synapse].toNeuron;
				if (toNeuron.parentNet.getName().compareTo("SomNet") == 0) {
					somToSom += somNet.neurons[neuronNum].synapses[synapse]
							.getWeight();
					relevantSynapses++;
				} else if (toNeuron.parentNet.getName().compareTo("HiddenNet") == 0) {
					somToHidden += somNet.neurons[neuronNum].synapses[synapse]
							.getWeight();
					forwardSynapses++;
				} else
					System.out.println("errir ");

			}
			somToSom /= relevantSynapses;
			somToHidden /= forwardSynapses;

			// hidden
			relevantSynapses = 0;
			forwardSynapses = 0;
			int backwardSynapses = 0;
			for (int synapse = 0; synapse < hiddenNet.neurons[neuronNum]
					.getCurrentSynapses(); synapse++) {
				CANTNeuron toNeuron = hiddenNet.neurons[neuronNum].synapses[synapse].toNeuron;
				if (toNeuron.parentNet.getName().compareTo("HiddenNet") == 0) {
					hiddenToHidden += hiddenNet.neurons[neuronNum].synapses[synapse]
							.getWeight();
					relevantSynapses++;
				} else if (toNeuron.parentNet.getName().compareTo("OutputNet") == 0) {
					hiddenToOutput += hiddenNet.neurons[neuronNum].synapses[synapse]
							.getWeight();
					forwardSynapses++;
				} else if (toNeuron.parentNet.getName().compareTo("SomNet") == 0) {
					hiddenToSom += hiddenNet.neurons[neuronNum].synapses[synapse]
							.getWeight();
					backwardSynapses++;
				} else
					System.out.println("error ");
			}
			hiddenToHidden /= relevantSynapses;
			hiddenToOutput /= forwardSynapses;
			hiddenToSom /= backwardSynapses;

			// output
			if (neuronNum < 150) {
				relevantSynapses = 0;
				backwardSynapses = 0;
				for (int synapse = 0; synapse < outputNet.neurons[neuronNum]
						.getCurrentSynapses(); synapse++) {
					CANTNeuron toNeuron = outputNet.neurons[neuronNum].synapses[synapse].toNeuron;
					if (toNeuron.parentNet.getName().compareTo("OutputNet") == 0) {
						outputToOutput += outputNet.neurons[neuronNum].synapses[synapse]
								.getWeight();
						relevantSynapses++;
					} else if (toNeuron.parentNet.getName().compareTo(
							"HiddenNet") == 0) {
						outputToHidden += outputNet.neurons[neuronNum].synapses[synapse]
								.getWeight();
						backwardSynapses++;
					}
				}
				outputToOutput /= relevantSynapses;
				outputToHidden /= backwardSynapses;
			}

			System.out.print(neuronNum + " " + inputToSom + " " + somToSom
					+ " ");
			System.out.print(somToHidden + " " + hiddenToHidden + " "
					+ hiddenToSom);
			System.out.println(" " + hiddenToOutput + " " + outputToOutput
					+ " " + outputToHidden);
		}
	}

  public void switchLearningOff() {
	    shepardCNet inputNet = (shepardCNet) getNet("BaseNet");
		shepardCNet pairNet = (shepardCNet) getNet("PairNet");
		shepardCNet tripleNet = (shepardCNet) getNet("TripleNet");
		shepardCNet somNet = (shepardCNet) getNet("SomNet");
		shepardCNet hiddenNet = (shepardCNet) getNet("HiddenNet");
		shepardCNet outputNet = (shepardCNet) getNet("OutputNet");
		    
		//inputNet.setCurrentPattern(0);
		inputNet.setLearningOn(false);
		pairNet.setLearningOn(false);
		tripleNet.setLearningOn(false);
		somNet.setLearningOn(false);
		hiddenNet.setLearningOn(false);
		outputNet.setLearningOn(false);
  }
  
  public void switchToTest () {
    System.out.println("swithctotest " + shepardCCANT.ExperimentXMLFile);
    inTest = true;
   // CANT23.isRunning = false;
    //switchLearningOff();
	//printSynapticStrength();
  }
  
  private void  printNumFiring(int currentStep) {
		shepardCNet somNet = (shepardCNet) getNet("SomNet");
		shepardCNet hiddenNet = (shepardCNet) getNet("HiddenNet");
		int numSomFiring = 0;
		int numHiddenFiring = 0;
		
		for (int i = 0; i < somNet.getSize(); i ++){
			if (somNet.neurons[i].getFired()) numSomFiring++;
			if (hiddenNet.neurons[i].getFired()) numHiddenFiring++;
		}
		
		//System.out.println(currentStep + " " + numSomFiring + " " + numHiddenFiring);  
  }
  
  public boolean isEndEpoch(int currentStep) {
	shepardCNet inputNet = (shepardCNet) getNet("BaseNet");
	
	if ((currentStep %5000) == 0)
	  {
		//inputNet.printSomLocales();
		//inputNet.setLearningRate(inputNet.getLearningRate()*0.7f);
	   }
	printNumFiring(currentStep);
	
    if ((currentStep% inputNet.getCyclesPerRun()) == 0 ) 
    	{
    	shepardCCANT.resetForNewTest();
    	return (true);
    	}
    return (false);
    
}
  //put the train som net into a fired array.  We'll use this to 
  //compare later.
	private void saveTrainNet() {
		shepardCNet somNet = (shepardCNet) getNet("SomNet");
		//int measureStep = shepardCCANT.CANTStep - 55;
		for (int measureStep = shepardCCANT.CANTStep -75; 
				measureStep < shepardCCANT.CANTStep; measureStep++)
		for (int offset = 0; offset < somNet.getSize(); offset++) {
				trainTestNet[offset][trainTestInput] += somNet.measure
						.getActiveState(measureStep, offset);
		}
		trainTestInput++;
	}
	
	private void saveTheTestNet() {
		shepardCNet somNet = (shepardCNet) getNet("SomNet");

		for (int offset = 0; offset < somNet.getSize(); offset++) {
			testNet[offset] = 0;
		}

		//int measureStep = shepardCCANT.CANTStep - 30;
		for (int measureStep = shepardCCANT.CANTStep -75; 
				measureStep < shepardCCANT.CANTStep; measureStep++)
		for (int offset = 0; offset < somNet.getSize(); offset++) {
			testNet[offset] += somNet.measure.getActiveState(measureStep, offset);
		}
		trainTestInput++;
	}

	public void debugPrintTrainTestNets(){
	    for ( int counter = 0; counter < 1000; counter++ )
	       if ((trainTestNet[counter][0] == 0) &&
	           (trainTestNet[counter][1] == 0))
	    	   
		    System.out.println("dTTT " +  counter);
	}
	 
    int answers[];  //answers from the test data; the system doesn't know this.
    int answerCount=0;
    boolean testFileOpened = false;

	public void endEpoch() {
		int inputsOn = 50;
		int pairsOn = 60;
		int triplesOn = 60;
		int outputsOn = 20;
		// read a pattern from the file.
		shepardCNet inputNet = (shepardCNet) getNet("BaseNet");
		shepardCNet pairNet = (shepardCNet) getNet("PairNet");
		shepardCNet tripleNet = (shepardCNet) getNet("TripleNet");
		shepardCNet outputNet = (shepardCNet) getNet("OutputNet");
		if (inTest) {
            int curPattern = (inputNet.getCurrentPattern()+1)%inputNet.getTotalPatterns();
            inputNet.setCurrentPattern(curPattern);
            inputNet.selectPattern(curPattern);
            inputNet.setNeuronsToStimulate(inputsOn); 
            pairNet.setCurrentPattern(curPattern);
            pairNet.selectPattern(curPattern);
            pairNet.setNeuronsToStimulate(pairsOn); 
            tripleNet.setCurrentPattern(curPattern);
            tripleNet.selectPattern(curPattern);
            tripleNet.setNeuronsToStimulate(triplesOn); 
            outputNet.setNeuronsToStimulate(0);
            correctAnswer = curPattern%2;
		} else {
            inputNet.setNeuronsToStimulate(inputsOn); 
            pairNet.setNeuronsToStimulate(pairsOn); 
            tripleNet.setNeuronsToStimulate(triplesOn); 
            outputNet.setNeuronsToStimulate(outputsOn); 
            int curPattern = (inputNet.getCurrentPattern()+1)%inputNet.getTotalPatterns();
            //int curPattern = CANT23.random.nextInt(inputNet.getTotalPatterns());
            inputNet.setCurrentPattern(curPattern);
            inputNet.selectPattern(curPattern);
            pairNet.setCurrentPattern(curPattern);
            pairNet.selectPattern(curPattern);
            tripleNet.setCurrentPattern(curPattern);
            tripleNet.selectPattern(curPattern);
            outputNet.setCurrentPattern(curPattern);
            outputNet.selectPattern(curPattern);
		}
	}
  
 
  public double printConnectionWeights(int step, String netName) {
	double totWeight = 0;
	int posNeurons = 0;
	shepardCNet net = (shepardCNet) getNet(netName);
    
	for (int i = 0; i < net.getSize(); i++) {
	  if (!net.neurons[i].isInhibitory()) {
		posNeurons++;
	    for (int synapse=0;synapse < net.neurons[i].getCurrentSynapses(); synapse++) {
		  totWeight += net.neurons[i].synapses[synapse].getWeight(); 
	    }    	   
	  }
	}
	return totWeight/posNeurons;
	//System.out.println("Weights " + step + " " + totWeight/totSynapses);
  } 
    	
  public void printExpName () {
    System.out.println("shepardA Exp");
  }
  
    private int correctOutputCategorisations = 0;
    private int categorySize = 50;
	private void printAnotherDecision() {
		shepardCNet outputNet = (shepardCNet) getNet("OutputNet");
		int categoryA = 0;
		int categoryB = 0;
		int answer = 0;
		for (int measureStep = shepardCCANT.CANTStep - 75; measureStep < shepardCCANT.CANTStep; measureStep++) {
			for (int offset = 0; offset < categorySize; offset++) {
				if (outputNet.measure.getActiveState(measureStep, offset) == 1)
					categoryA++;
				if (outputNet.measure.getActiveState(measureStep, offset+categorySize) == 1)
					categoryB++;
			}
		}
		if (categoryA > categoryB)  answer = 0;
		else answer = 1;
		if (answer == correctAnswer) correctOutputCategorisations++;
		System.out.println("OutDec " + categoryA + " " + categoryB + " " + correctAnswer + " " + correctOutputCategorisations);
	}

	public void measure(int currentStep) {
		if (currentStep <= trainingLength)
			return;

		if (((currentStep - trainingLength) % 75) == 0) {
			printAnotherDecision();
		}
		if (currentStep == trainingLength + (75 * numTests)) {
			System.out.println("Decisions " + " "	+ correctOutputCategorisations);
		}
	}
  
} //end class

