


import java.util.Enumeration;

public class shepardCNet extends CANTNet {
	public shepardCNet() {
	}

	public shepardCNet(String name, int cols, int rows, int topology) {
		super(name, cols, rows, topology);
		cyclesToStimulatePerRun = 40;
		recordingActivation = true;
	}
	
	public int getNeuronsFired() {
		int result = 0;
		for (int i = 0 ; i < getSize(); i++)
			if (neurons[i].getFired()) result++;
		return result;
	}

	// This really slows down processing.
	public void updateIncomingStrengthsSlow() {
		for (int cNeuron = 0; cNeuron < getTotalNeurons(); cNeuron++) {
			CANTNeuronSpontaneousFatigue modNeuron = (CANTNeuronSpontaneousFatigue) neurons[cNeuron];
			modNeuron.setIncomingStrength(modNeuron.getIncomingStrength(3));
		}
	}

	public void zeroIncomingStrengths() {
		for (int cNeuron = 0; cNeuron < getTotalNeurons(); cNeuron++) {
			neurons[cNeuron].setIncomingStrength(0);
		}
	}

	// need this to subclass experiment
	public void changePattern(int cantStep) {
		// note this only runs on the first step. The rest of the time it
		// is in experiment.endEpoch.
		if (cantStep == 0) {
			if (getName().compareTo("OutputNet") == 0) {
				int curPattern = 0;
				setCurrentPattern(curPattern);
				((CANTPattern) patterns.get(curPattern))
						.arrange(getNeuronsToStimulate());
			} 
			else  {
				int curPattern = 0;
				setCurrentPattern(curPattern);
				//((CANTPattern) patterns.get(curPattern)).arrange(getNeuronsToStimulate());
			}
		}
	}
	  
	  public void readBetweenAllNets() {
	    int netsChecked = 0;
	    Enumeration <?> eNum = CANT23.nets.elements();
	    shepardCNet net = (shepardCNet) eNum.nextElement();
	    shepardCNet baseNet = net;
	    shepardCNet somNet = net;
	    shepardCNet hiddenNet = net;
	    shepardCNet outputNet = net;

	    System.out.println("shepard read Between");

	      shepardCNet gasNet = net;
	      do {
	        System.out.println(net.getName());
	        if (net.getName().compareTo("BaseNet") == 0)
	          baseNet = net;
	        else if (net.getName().compareTo("SomNet") == 0)
	          somNet = net;
	        else if (net.getName().compareTo("HiddenNet") == 0)
		          hiddenNet = net;
	        else if (net.getName().compareTo("OutputNet") == 0)
		          outputNet = net;
	        else
	          System.out.println(net.getName() + " missed net in connect all");
	        netsChecked++;
	        if (netsChecked < 4)
	          net = (shepardCNet) eNum.nextElement();
	      } while (netsChecked < 4);

	      baseNet.readConnectTo(somNet);
	      somNet.readConnectTo(hiddenNet);
	      hiddenNet.readConnectTo(somNet);
	      hiddenNet.readConnectTo(outputNet);
	      outputNet.readConnectTo(hiddenNet);
	  }
	  
	  
	  
	  public void runAllOneStep(int CANTStep) {  
	    //This series of loops is really chaotic, but I needed to
	    //get all of the propagation done in each net in step.
	    shepardCCANT.runOneStepStart();
		
	    Enumeration <?> eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      //net.runOneStep(CANTStep);
	      net.changePattern(CANTStep);
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.setExternalActivation(CANTStep);
	    }
	    
	    shepardCCANT.outputGlobInhibition.applyGlobalInhibition();
	    shepardCCANT.somGlobInhibition.applyGlobalInhibition();
	    shepardCCANT.pairGlobInhibition.applyGlobalInhibition();
	    shepardCCANT.hiddenGlobInhibition.applyGlobalInhibition();
	    //net.propogateChange();  
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.setNeuronsFired();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.setDecay ();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.spreadActivation();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.setFatigue();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.learn();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      net.cantFrame.runOneStep(CANTStep+1);
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      shepardCNet net = (shepardCNet)eNum.nextElement();
	      if (net.recordingActivation) net.setMeasure(CANTStep); 	  
	    }
	  }


	public CANTNet getNewNet(String name, int cols, int rows, int topology) {
		shepardCNet net = new shepardCNet(name, cols, rows, topology);
		return (net);
	}

  private int InternalSomSynapses = 10;
  private int InternalHiddenSynapses = 10;
  private int InternalOutputSynapses = 10;
  
  private int InputToSomSynapses = 20; 
  private int PairToSomSynapses = 0;
  private int TripleToSomSynapses = 10;
  private int SomToHiddenSynapses = 10;
  private int SomToOutputSynapses = 0;
  private int HiddenToSomSynapses = 15;
  private int HiddenToOutputSynapses = 10;
  private int OutputToHiddenSynapses = 10;
  private int OutputToSomSynapses = 0;

	protected void createNeurons() {
		double compensatoryBase = 10.0;
		if (topology == 1) {
			totalNeurons = 0;
			neurons = new CANTNeuron[cols * rows];
			for (int i = 0; i < cols * rows; i++) {
				neurons[i] = new CANTNeuron(totalNeurons++, this);
				// neurons[i] = new
				// CANTNeuronSpontaneousFatigue(totalNeurons++,this);
				neurons[i].setCompensatoryBase(compensatoryBase);
				neurons[i].setInhibitory(false);
			}
		} else if (topology == 2) {
			System.out.println(" creating fatigue neurons ");
			totalNeurons = 0;
			neurons = new CANTNeuronSpontaneousFatigue[cols * rows];
			for (int i = 0; i < cols * rows; i++) {
				neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,
						this);
				neurons[i].setCompensatoryBase(compensatoryBase);
			}
			setInitialFatigue();
		} else if (topology == 3) {
			System.out.println(" creating fatigue neurons ");
			totalNeurons = 0;
			neurons = new CANTNeuronSpontaneousFatigue[cols * rows];
			for (int i = 0; i < cols * rows; i++) {
				neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,
						this);
				neurons[i].setCompensatoryBase(compensatoryBase);
			}
			setInitialFatigue();
		} else if (topology == 4) {
			System.out.println(" creating fatigue neurons ");
			totalNeurons = 0;
			neurons = new CANTNeuronSpontaneousFatigue[cols * rows];
			for (int i = 0; i < cols * rows; i++) {
				neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,
						this);
				neurons[i].setCompensatoryBase(compensatoryBase);
			}
			setInitialFatigue();
		} else if (topology == 5) {
			System.out.println(" creating fatigue neurons ");
			totalNeurons = 0;
			neurons = new CANTNeuronSpontaneousFatigue[cols * rows];
			for (int i = 0; i < cols * rows; i++) {
				neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,
						this);
				neurons[i].setCompensatoryBase(compensatoryBase);
			}
			setInitialFatigue();
		} else
			System.out.println("error in shepardCNet.createNuerons ");
	}
	  
	public void connectBaseToSomNet(shepardCNet somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses = InputToSomSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}

	
	
	public void connectSomToHiddenNet(shepardCNet hiddenNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = SomToHiddenSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(hiddenNet.getSize());
				neurons[fromNeuron].addConnection(hiddenNet.neurons[toNeuron],
						0.001);
			}
		}
	}
	
	public void connectSomToOutputNet(shepardCNet outputNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses = SomToOutputSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(outputNet.getSize());
				neurons[fromNeuron].addConnection(outputNet.neurons[toNeuron],
						0.001);
			}
		}
	}

	public void connectPairToSomNet(shepardCNet somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = PairToSomSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}
	
	public void connectTripleToSomNet(shepardCNet somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = TripleToSomSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}
	
	public void connectHiddenToSomNet(shepardCNet somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses = HiddenToSomSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}

	public void connectHiddenToOutputNet(shepardCNet outputNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses = HiddenToOutputSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(outputNet.getSize());
				neurons[fromNeuron].addConnection(outputNet.neurons[toNeuron],
						0.001);
			}
		}
	}

	public void connectOutputToHiddenNet(shepardCNet hiddenNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = OutputToHiddenSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(hiddenNet.getSize());
				neurons[fromNeuron].addConnection(hiddenNet.neurons[toNeuron],
						0.001);
			}
		}
	}
	
	public void connectOutputToSomNet(shepardCNet somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = OutputToSomSynapses;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}

	
	  protected void setConnections() {
	    for(int i=0;i< cols*rows;i++)
	      {
	      if (neurons[i].isInhibitory())
	        setConnectionsRandomly(i,20,0.01);
	      else
	        setConnectionsRandomly(i,20,0.01);
	      }
	  }

	  //Fatigue should be relatively random to start.
	  public void setInitialFatigue() {
	    for(int i=0;i< cols*rows;i++) {
	      float newFatigue = CANT23.random.nextFloat();
	      newFatigue *= getActivationThreshold()*2;
	      newFatigue -= getActivationThreshold();
	      neurons[i].setFatigue(newFatigue);
	    }
	  }

	  //set fatigue between threshold and bottomVal
	  public void setInitialFatigue(double bottomVal) {
	    double range = getActivationThreshold() - bottomVal;
	    for(int i=0;i< cols*rows;i++) {
	      float newFatigue = CANT23.random.nextFloat();
	      newFatigue *= range;
	      newFatigue += bottomVal;
	      neurons[i].setFatigue(newFatigue);
	    }
	  }

	  private void setInputTopology() {
	      //setConnections(); no internal connections
	  }
	  
	private void setSOMTopology() {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int internalSynapses;
			neurons[fromNeuron].setInhibitory(false);
			internalSynapses = InternalSomSynapses;
			for (int synapses = 0; synapses < internalSynapses; synapses++) {
				int toNeuron = CANT23.random.nextInt(getSize());
				addConnection(fromNeuron, toNeuron, 0.02);
			}
		}
	}
		
	private void setHiddenTopology() {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int internalSynapses;
			neurons[fromNeuron].setInhibitory(false);
			internalSynapses = InternalHiddenSynapses;
			for (int synapses = 0; synapses < internalSynapses; synapses++) {
				int toNeuron = CANT23.random.nextInt(getSize());
				addConnection(fromNeuron, toNeuron, 0.02);
			}
		}
	}
	  
	private void setOutputTopology() {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int internalSynapses;
			neurons[fromNeuron].setInhibitory(false);
			internalSynapses = InternalOutputSynapses;
			for (int synapses = 0; synapses < internalSynapses; synapses++) {
				int toNeuron = CANT23.random.nextInt(getSize());
				addConnection(fromNeuron, toNeuron, 0.02);
			}
		}
	}

	public void initializeNeurons() {
		// set up topologies.
		createNeurons();

		if (topology == 1) {
			// System.out.println("shepard input topology ");
			setInputTopology();
		} else if (topology == 2) {
			// System.out.println("shepard som topology ");
			setSOMTopology();
		} else if (topology == 3) {
			// System.out.println("shepard hidden topology ");
			setHiddenTopology();
		} else if (topology == 4) {
			// System.out.println("shepard output topology ");
			setOutputTopology();
		} else
			System.out.println("bad toppology specified " + topology);
	}

	  private double getTotalWeights(CANTNeuron neuron) {
	    double toWeight = 0.0;
	    for (int synapse = 0; synapse < neuron.getCurrentSynapses(); synapse ++) {
	      toWeight += neuron.synapses[synapse].getWeight();
	    }
	    return (toWeight);
	  }


	  public void learn() {
		int learningOn = getLearningOn();
	    if (learningOn == 0) return;
	    else if (learningOn == 1)
	    {
		    int totalNeurons = size();
		    for (int neuronIndex = 0; neuronIndex < totalNeurons; neuronIndex++) 
		      {
		      String netName = getName();
		      
		      //pre,post,post,post
		      if ((netName.equals("BaseNet")) ||(netName.equals("PairNet")) ||(netName.equals("TripleNet")) )  		
		        neurons[neuronIndex].learn4();
		      else if ((netName.equals("SomNet")) || (netName.equals("HiddenNet")) ||
		    		   (netName.equals("OutputNet")))
	//if ((neuronIndex == 0) && neurons[0].getFired())	    	  
	//System.out.println(" neuron 0 fired " + shepardCCANT.CANTStep); 
			    neurons[neuronIndex].learnPostCompense();
		      //post,pre,pre,pre
				/*if (netName.equals("BaseNet"))
					neurons[neuronIndex].learnPostCompense();
				else if ((netName.equals("SomNet"))
						|| (netName.equals("HiddenNet"))
						|| (netName.equals("OutputNet")))
					neurons[neuronIndex].learn4();
		      //post,post,post,post
   			  neurons[neuronIndex].learn4();
*/				
			}
	    }
	    else 
	    	System.out.println(" bad learning on in shepardCNet learn " + learningOn); 
	 }
	  
	  

	  public void kludge () {
	    System.out.println("kludge " + shepardCCANT.kludge );
	    shepardCNet net = (shepardCNet) CANT23.experiment.getNet("SomNet");

	    
	    if (shepardCCANT.kludge == 0) {
	      net = (shepardCNet) CANT23.experiment.getNet("BaseNet");
	      for (int i= 0; i < 10; i++) 
	        {
	        double totalWeights = getTotalWeights(net.neurons[i]);
	        System.out.println(i + " " + totalWeights + " " +  net.neurons[i].getFatigue()); 
	        }
	    }
	    else if (shepardCCANT.kludge == 1) {
	    	  System.out.print(this.getName());
		      for (int i= 0; i < 10; i++) 
		        {
		    	double outWeights = getTotalWeights(this.neurons[i]);
		        double inWeights = this.neurons[i].getIncomingStrength();
		        System.out.println(i + " " + outWeights + " " + inWeights); 
		        }
	      }

	    else if (shepardCCANT.kludge == 3) {
	        for (int i= 0; i < 10; i++) 
	          {
	          System.out.println(i + " " +  net.neurons[i].getFatigue()); 
	          }
	      }
	    else if (shepardCCANT.kludge == 4) {
	    	System.out.println("kludge " + shepardCCANT.kludge );
	      }
	    else {
	        for (int i= 0; i < 10; i++) 
	        {
	        System.out.println(i + " act " +  net.neurons[i].getActivation()); 
	        }
	    }
	    /*
	           double avgWeights;
	      double totalWeights = getTotalWeights(net.neurons[i]);
	      avgWeights = getTotalWeights(net.neurons[i],"OutputNet");
	      System.out.println(i + " " + avgWeights + " " + totalWeights); 
	      //System.out.println(i + " " + this.neurons[i].getActivation() + 
	      //                      " " + this.neurons[i].getFatigue());
	      */
	  }
	  
	  public void measure(int currentStep) {
	    System.out.println("measure " + neurons[0].getActivation() + " " + 
	      neurons[0].getFired() + " " + 
		  currentStep);
	  }
	}